use std::fs;

/// Read multiple hex‐encoded u64s (one per line)
pub fn load_vec_u64_hex(path: &str) -> Vec<u64> {
    fs::read_to_string(path)
        .expect("failed to read file")
        .lines()
        .map(|l| u64::from_str_radix(l.trim_start_matches("0x").trim(), 16).unwrap())
        .collect()
}
