mod des;
mod dfa;
mod file_helper;

use crate::des::des_encrypt;
use crate::dfa::{apply_parity, find_k16, find_k64};
use crate::file_helper::load_vec_u64_hex;

fn main() {
    let correct_values = load_vec_u64_hex("cleartextciphertext.txt");
    let clear = correct_values[0];
    let cipher = correct_values[1];

    let faults = load_vec_u64_hex("faults.txt");

    let k16 = find_k16(cipher, &faults);
    println!("Recovered K16 = 0x{:012x}", k16);

    let k64_no_parity = find_k64(clear, cipher, k16);
    let k64 = apply_parity(k64_no_parity);
    println!("Full DES key = 0x{:016x}", k64);

    // verification
    let test = des_encrypt(clear, k64);
    println!("Verification: got ciphertext 0x{:016x}", test);
    println!("correct ciphertext was 0x{:016x}", cipher);
    println!("matching ciphertexts: {}", test == cipher);
}
